'-- alc7t.bas -------------------------------------------------- >>fst'06<< -
' - Steuerprogramm und Datenlogger fuer das Ladegeraet
'   ALC 7000 Expert von ELV-Elektronik;  Version 1.26 .
' - Alle 4 Ladekanaele werden ausgelesen.
' - Die Messdaten-Dateien sind kompatibel zum Freeware-Programm GRAPH.EXE
'   von James R. Van Zandt. Damit kann der Spannungsverlauf nach
'   Programmende als Liniendiagramm angezeigt werden (alc.bat, alcXP.bat).
' - Open Source;
'   keine kommerzielle Verwendung ohne Zustimmung des Urhebers.
'-- V 20061009 ------------------------------- http://www.FrankSteinberg.de -

DECLARE FUNCTION AuswahlAEI$ ()
DECLARE SUB StrukturAEI ()
DECLARE SUB DOS ()
DECLARE FUNCTION tStatus$ (x%)
DECLARE FUNCTION Praefix$ ()
DECLARE SUB KorrI34 (FehlerLL%)
DECLARE SUB IRichtgNeu ()
DECLARE SUB DateiKopf ()
DECLARE SUB DateiStart ()
DECLARE SUB KanISTTaste ()
DECLARE SUB KanInit ()
DECLARE SUB ALCmess ()
DECLARE SUB COMoeffnen ()
DECLARE FUNCTION BasisAdr% (x%)
DECLARE FUNCTION DateiVorh% (DName$)
DECLARE SUB ProgrammEnde ()
DECLARE SUB Einstellungen ()
DECLARE SUB EndeAbfrage ()
DECLARE SUB ALCsuchen (Zeichen%)
DECLARE SUB RegSichern (BA%, sik%())
DECLARE SUB RegRestaurieren (BA%, sik%())
DECLARE SUB ALCText (Text$, Zeichen%)
DECLARE SUB FehlerSer ()
DECLARE SUB WertInDatei ()
DECLARE FUNCTION tStromrichtg$ (x%)
DECLARE FUNCTION Zeitmess! ()
DECLARE SUB Kapazitaet ()
DECLARE FUNCTION Zeit$ (Sekux!)
DECLARE FUNCTION Tmr! ()
DECLARE SUB Ende ()
DECLARE FUNCTION aEntladestrom! ()
DECLARE FUNCTION aNennKap! ()
DECLARE FUNCTION aProgramm$ ()
DECLARE FUNCTION aAkkutyp$ (UZelle!)
DECLARE FUNCTION aZellenzahl% ()
DECLARE FUNCTION tZustand$ (x%)
DECLARE FUNCTION aLadestrom! ()
DECLARE SUB CGrenzwert ()
DECLARE SUB AnzEinstell ()
DECLARE SUB UMinMax ()
DECLARE SUB DeltaPeak ()
DECLARE SUB Maske (Version$)
DECLARE SUB AnzMesswerte ()
DECLARE SUB ALCsend (Bef$, Kan%, Par%)
DECLARE FUNCTION ALCempf% (FehlerEmpf%)


'Messwerte vom ALC7000:
DIM SHARED UMess(4), IMess(4), CMess(4), CMessAlt(4)
'errechnete Messwerte:
DIM SHARED UMin(4), UMax(4), DPMax(4), DP(4), CLad(4), CLadGr(4), CEntl(4), CEntlAlt(4)
'Geraete-Einstellungen:
DIM SHARED Prog%(4), AnzZellen%(4), UNenn(4), ILad(4), IEntl(4), CNenn(4), AKTyp%(4)
'Geraete-Einstellungen als Text:
DIM SHARED Programm$(4), Akkutyp$(4)
'Geraete-Status:
DIM SHARED KanStatus%(4), AkStatus%(4), IRichtg%(4), IRichtgAlt%(4)
'Zeiten:
DIM SHARED TStart(4), Seku(4), SekuAlt(4), TAlt(4), Tage&(4)
'Ablaufkontrolle:
DIM SHARED Taste$, Fehler$, Spalte%, Beenden%, Kan%, IStart(4), Aufz%(4), CFlag%(4), CGrFlag%(4), Sequ34%
'Datei- und Schnittstellenbehandlung:
DIM SHARED BA%, COMNr%, EDatei$(4), MDatei$(4)
'Sonstiges:
DIM SHARED Beschreibung$(4), Fenstertext$, TimeOut%

'Fehlerbehandlung nach 3 Sek. ohne Datenempfang:
ON TIMER(3) GOSUB TimeOut0

'COM1 und COM2 nach ALC7000 absuchen:
CALL ALCsuchen(Zeichen%)
'BA% = &H3F8: COMNr% = 1: CALL COMoeffnen(BA%, COMNr%)

'Fehlerbehandlung nach 3 Sek. ohne Datenempfang:
ON TIMER(3) GOSUB TimeOut1

'Geraeteversion abrufen:
PRINT #5, CHR$(2) + "V" + CHR$(3);
CALL ALCText(Version$, Zeichen%)
Version$ = LEFT$(Version$ + "  ", 6)

'Wert fuer Minimalspannung vorbelegen:
FOR Kan% = 1 TO 4
 UMin(Kan%) = 99.999   'Wert fuer Minimalspannung vorbelegen
 IStart(Kan%) = .009   'Schwell-Strom bei dem die Aufzeichnung gestartet wird
 CALL DateiStart       'alte Messdatendateien sichern
NEXT

'Bildschirmmaske erzeugen:
CALL Maske(Version$)

'Fehlerbehandlung bei allgemeinen Fehlern:
ON ERROR GOTO Fehler

DO '--- H A U P T S C H L E I F E ----------------------------------------------

 FOR Kan% = 1 TO 4          '4 Kanaele nacheinander abarbeiten

Start:
  'Indikator fuer Zeitueberwachung Datenempfang zuruecksetzen:
  TimeOut% = 0

  'Akkustatus abrufen:
  CALL ALCsend("s", Kan%, 0): AkStatus%(Kan%) = ALCempf%(FehlerEmpf%)
 
  'Kanalstatus abrufen,wenn nicht Grenze der Ladekapazitaet ueberschritten :
   IF KanStatus% <> 4 THEN
    CALL ALCsend("a", Kan%, 0)
    KanStatus%(Kan%) = ALCempf%(FehlerEmpf%)
   END IF

  'Stromrichtung von vorheriger Messung speichern:
  IRichtgAlt%(Kan%) = IRichtg%(Kan%)
  'Aktuelle Stromrichtung abrufen:
  CALL ALCsend("h", Kan%, 0): IRichtg%(Kan%) = ALCempf%(FehlerEmpf%)
  'Bei erster Messung ist Alt=Neu:
  IF IRichtgAlt%(Kan%) = 0 THEN IRichtgAlt%(Kan%) = IRichtg%(Kan%)

  'Spannung/Strom/Kapazitaet abrufen:
  CALL ALCsend("w", Kan%, 0): CALL ALCmess
 
  'Wiederholen, bei Zeitueberschreitung bei Datenempfang
  IF TimeOut% GOTO Start

  'Min/Max-Spannung berechnen:
  CALL UMinMax
 
  'Delta-Peak berechnen, wenn Akku geladen wird:
  IF (AkStatus%(Kan%) = 1) THEN CALL DeltaPeak

  'Aufzeichnung starten, wenn Kanal aktiv und Strom fliesst:
  IF (KanStatus%(Kan%) = 1) AND (AkStatus%(Kan%) = 1) AND (Aufz%(Kan%) < 2) AND (IMess(Kan%) > IStart(Kan%)) THEN
   SOUND 4000, 2
   TStart(Kan%) = Tmr                  'Zeitmessung starten
   TAlt(Kan%) = 0: SekuAlt(Kan%) = 0   'Invervallmessung ruecksetzen
   IF Aufz%(Kan%) = 0 THEN
    CALL AnzEinstell                   'aktuelle Einstellungen abrufen
   END IF
   CALL DateiKopf
   Aufz%(Kan%) = 2                     'Indikator: Aufzeichnen
  END IF

  'Laufzeit berechnen:
  IF (KanStatus%(Kan%) = 1) AND (Aufz%(Kan%) = 2) THEN Seku(Kan%) = Zeitmess
 
  'Eingeladene und entladene Kapazitaet berechnen:
  'IF Seku(Kan%) > 60 THEN CMess(Kan%) = 0
  CALL Kapazitaet
 
  'Programmstopp bei Ueberschreitung des Ladekapazitaets-Grenzwertes:
  CALL CGrenzwert
 
  'Alle Werte anzeigen:
  CALL AnzMesswerte

  'Bei Aenderung der Stromrichtung Kapazitaet in Datei schreiben und
  'Datei zwischenspeichern:
  CALL IRichtgNeu
 
  'Wenn Kanal aktiv und Stromrichtung unveraendert,
  'Werte in Datendatei schreiben:
  CALL WertInDatei

  'Wenn Akku voll oder entladen, Dateien schliessen:
  IF (AkStatus%(Kan%) > 1) AND (Aufz%(Kan%) = 2) THEN CALL ProgrammEnde
  IF (KanStatus%(Kan%) = 0) AND (Aufz%(Kan%) = 2) THEN CALL ProgrammEnde
  'IF CGrFlag%(Kan%) THEN CALL ProgrammEnde

  'Wenn Alt+d gedrueckt, DOS-Oberflaeche starten:
  IF RIGHT$(Taste$, 1) = CHR$(32) THEN CALL DOS
 
  'Wenn Taste 1,2,3 oder 4 gedrueckt, Einstellungen abfragen und auslesen:
  IF Taste$ = "1" OR Taste$ = "2" OR Taste$ = "3" OR Taste$ = "4" THEN
   SOUND 4000, 2
   OKan% = Kan%
   CALL KanISTTaste
   IF Aufz%(Kan%) = 2 THEN
     Fenstertext$ = " - Laufendes Programm NEU STARTEN ! -"
    ELSE
     Fenstertext$ = "         - Programm starten -"
   END IF
   CALL Einstellungen
   Kan% = OKan%
  END IF

  'Wenn Taste Shift + 1,2,3 oder 4 gedrueckt, Werte und Dateien des Kanals
  'zuruecksetzen, dann Einstellungen abfragen und auslesen:
  IF Taste$ = "!" OR Taste$ = CHR$(34) OR Taste$ = CHR$(21) OR Taste$ = CHR$(245) OR Taste$ = "$" THEN
   SOUND 4000, 2
   OKan% = Kan%
   CALL KanISTTaste
   IF Aufz%(Kan%) = 2 THEN CALL ProgrammEnde
   Fenstertext$ = "* Alle Werte lschen und neu starten *"
   CALL KanInit
   CALL Einstellungen
   Kan% = OKan%
  END IF

 'Tastaturspeicher und Taste$ loeschen:
  Taste$ = INKEY$: Taste$ = ""


 'Naechsten Kanal bearbeiten:
 NEXT Kan%


LOOP '--- E N D E   H A U P T S C H L E I F E -------------------------------


'Abschlussbehandlung fuer Schnittstelle, Dateien und Bildschirm:
CALL Ende


'--- Fehlerbehandlungen -----------------------------------------------------

TimeOut0:
 Zeichen% = 3
 PRINT "ALC7000 nicht gefunden"
 PRINT
RETURN

TimeOut1:
 TIMER OFF
 CALL FehlerSer
 TimeOut% = -1
 TIMER ON
RETURN

Fehler:
 Fehler$ = Fehler$ + "*" + TIME$ + ": Kanal" + STR$(Kan%) + "; Basic-Fehler Nr" + STR$(ERR) + "; Gert Nr" + STR$(ERDEV)
 Fehler$ = RIGHT$(Fehler$, 80)
 LOCATE 25, 1: PRINT Fehler$;
 CALL AnzMesswerte
  FOR k% = 1 TO 4
   CLOSE #k%
   IF DateiVorh%(MDatei$(k%)) THEN OPEN MDatei$(k%) FOR APPEND AS #k%
  NEXT
 CALL FehlerSer
RESUME Start

FUNCTION aAkkutyp$ (UZelle)
'Abruf des Akkutyps

 DO
  CALL ALCsend("t", Kan%, 0)
  x% = ALCempf%(FehlerEmpf%)
  SELECT CASE x%
   CASE 0
    aAkkutyp$ = "NiCd/NiMH"
    UZelle = 1.2
   CASE 1
    aAkkutyp$ = "Blei     "
    UZelle = 2
   CASE ELSE
    x$ = LTRIM$(STR$(x%))
    aAkkutyp$ = "   ?" + x$ + "?   "
  END SELECT
 LOOP WHILE FehlerEmpf%

END FUNCTION

FUNCTION aEntladestrom!
'Abruf des eingestellten Entladestroms

 DO
  CALL ALCsend("e", Kan%, 0)
  aEntladestrom = ALCempf%(FehlerEmpf%) / 1000
 LOOP WHILE FehlerEmpf%

END FUNCTION

FUNCTION aLadestrom!
'Abruf des eingestellten Ladestroms

 DO
  CALL ALCsend("i", Kan%, 0)
  aLadestrom = ALCempf%(FehlerEmpf%) / 1000
 LOOP WHILE FehlerEmpf%

END FUNCTION

FUNCTION ALCempf% (FehlerEmpf%)
'empfaengt einen Ein-Byte oder einen Zwei-Byte Wert vom ALC7000 und erzeugt
'daraus einen Messwert. Steuerzeichen werden ausgefiltert. Bei unplausibler
'Rahmenlaenge wird (FehlerEmpf%) auf -1 gesetzt.
'Tastendruecke werden waehrend des Wartens auf Daten abgefragt.

TIMER ON  'Zeitueberwachung aktivieren

 'Auf Start-Byte CHR$(2) warten:
 DO
  IF LOC(5) THEN Byte1% = ASC(INPUT$(1, #5))
  IF Taste$ = "" THEN Taste$ = UCASE$(INKEY$)
  LOCATE 12, 28
  PRINT "";    'verhindert, dass Stromsparmodus Programmausfuehrung stoppt!
  IF TimeOut% THEN
   Fehler$ = Fehler$ + "*TimeOut Empfang"
   FehlerEmpf% = -1
   EXIT FUNCTION
  END IF
 LOOP UNTIL Byte1% = 2

 'Weitere Bytes lesen, bis Ende-Byte CHR$(3) erkannt:
 DO
  IF LOC(5) THEN
   Byte$ = INPUT$(1, #5)
   Dat$ = Dat$ + Byte$
   Byte1% = ASC(Byte$)
  END IF
  IF Taste$ = "" THEN Taste$ = UCASE$(INKEY$)
  IF TimeOut% THEN EXIT FUNCTION
 LOOP UNTIL Byte1% = 3

TIMER OFF  'Zeitueberwachung deaktivieren

 'Daten muessen zwischen 1 und 4 Zeichen lang sein + Ende-Zeichen:
 IF LEN(Dat$) < 2 OR LEN(Dat$) > 5 THEN
  Fehler$ = Fehler$ + "*Formatfehler bei Empfang"
  FehlerEmpf% = -1
  EXIT FUNCTION
 END IF

 '-------------------------------------------------------------------
 'CHR$(2), CHR$(3) und CHR$(5) sind Steuerzeichen. Die entsprechenden
 'Werte werden durch eine Folge von zwei Bytes wie folgt uebertragen:
 '2  =  CHR$(5) + CHR$(12hex)
 '3  =  CHR$(5) + CHR$(13hex)
 '5  =  CHR$(5) + CHR$(15hex)
 '--------------------------------------------------------------------

 Posi% = 1
 Byte1% = ASC(MID$(Dat$, 1, 1))

 IF Byte1% = 5 THEN
  Posi% = 2
  Byte1% = ASC(MID$(Dat$, Posi%, 1)) - &H10
 END IF

 Posi% = Posi% + 1
 Byte2% = ASC(MID$(Dat$, Posi%, 1))

 IF Byte2% = 3 THEN Byte2% = 0

 IF Byte2% = 5 THEN
  Posi% = Posi% + 1
  Byte2% = ASC(MID$(Dat$, Posi%, 1)) - &H10
 END IF

 IF Byte2% THEN
   ALCempf% = Byte2% + Byte1% * 256
  ELSE
   ALCempf% = Byte1%
 END IF

 'Wenn [Esc] gedrueckt wurde Abfrage, ob beendet werden soll:
 IF Taste$ = CHR$(27) THEN CALL EndeAbfrage
 IF Beenden% = 1 THEN CALL EndeAbfrage

END FUNCTION

SUB ALCmess
'empfaengt einen 3mal Zwei-Byte Messwert vom ALC7000 und erzeugt
'daraus je einen Messwert fuer Spannung, Strom und Kapazitaet.
'Steuerzeichen werden ausgefiltert. Bei unplausibler Rahmenlaenge werden
'die Messwerte nicht aktualisiert.
'Tastendruecke werden waehrend des Wartens auf Daten abgefragt.


TIMER ON  'Zeitueberwachung aktivieren

 'Auf Start-Byte CHR$(2) warten:
 DO
  IF LOC(5) THEN Byte1% = ASC(INPUT$(1, #5))
  IF Taste$ = "" THEN Taste$ = UCASE$(INKEY$)
  LOCATE 12, 28
  PRINT "";    'verhindert, dass Stromsparmodus Programmausfuehrung stoppt!
  IF TimeOut% THEN
   Fehler$ = Fehler$ + "*TimeOut Daten"
   FehlerEmpf% = -1
   EXIT SUB
  END IF
 LOOP UNTIL Byte1% = 2
 

 'Weitere Bytes lesen, bis Ende-Byte CHR$(3) erkannt:
 DO
  IF LOC(5) THEN
   Byte$ = INPUT$(1, #5)
   Dat$ = Dat$ + Byte$
   Byte1% = ASC(Byte$)
  END IF
  IF Taste$ = "" THEN Taste$ = UCASE$(INKEY$)
  IF TimeOut% THEN EXIT SUB
 LOOP UNTIL Byte1% = 3

 TIMER OFF  'Zeitueberwachung deaktivieren

 'Daten muessen zwischen 6 und 12 Zeichen lang sein + Ende-Zeichen:
 IF LEN(Dat$) < 7 OR LEN(Dat$) > 13 THEN
  Fehler$ = Fehler$ + "*Formatfehler bei Empfang"
  EXIT SUB
 END IF

 '-------------------------------------------------------------------
 'CHR$(2), CHR$(3) und CHR$(5) sind Steuerzeichen. Die entsprechenden
 'Werte werden durch eine Folge von zwei Bytes wie folgt uebertragen:
 '2  =  CHR$(5) + CHR$(12hex)
 '3  =  CHR$(5) + CHR$(13hex)
 '5  =  CHR$(5) + CHR$(15hex)
 '--------------------------------------------------------------------

 '3 Messwerte ausfiltern:
 FOR j% = 1 TO 3

  Posi% = Posi% + 1
  Byte1% = ASC(MID$(Dat$, Posi%, 1))
 
  IF Byte1% = 5 THEN
   Posi% = Posi% + 1
   Byte1% = ASC(MID$(Dat$, Posi%, 1)) - &H10
  END IF
 
  Posi% = Posi% + 1
  Byte2% = ASC(MID$(Dat$, Posi%, 1))

  IF Byte2% = 5 THEN
   Posi% = Posi% + 1
   Byte2% = ASC(MID$(Dat$, Posi%, 1)) - &H10
  END IF

  IF j% = 1 THEN U& = Byte2% + Byte1% * 256
  IF j% = 2 THEN I% = Byte2% + Byte1% * 256
  IF j% = 3 THEN k% = Byte2% + Byte1% * 256

 NEXT

 UMess(Kan%) = U& / 1000
 IMess(Kan%) = I% / 1000
 CMess(Kan%) = k% / 100

 'Wenn [Esc] gedrueckt wurde Abfrage, ob beendet werden soll:
 IF Taste$ = CHR$(27) THEN CALL EndeAbfrage
 IF Beenden% = 1 THEN CALL EndeAbfrage

END SUB

SUB ALCsend (Bef$, Kan%, Par%)
 'Datenblock fuer Befehle an das ALC7000 erzeugen und absenden.
 '-------------------------------------------------------------------
 'CHR$(2), CHR$(3) und CHR$(5) sind Steuerzeichen. Die entsprechenden
 'Werte werden durch eine Folge von zwei Bytes wie folgt uebertragen:
 '2  =  CHR$(5) + CHR$(12hex)
 '3  =  CHR$(5) + CHR$(13hex)
 '5  =  CHR$(5) + CHR$(15hex)
 '--------------------------------------------------------------------


SELECT CASE Kan%
 CASE 1
  Kan$ = CHR$(0)
 CASE 2
  Kan$ = CHR$(1)
 CASE 3
  Kan$ = CHR$(5) + CHR$(&H12)
 CASE 4
  Kan$ = CHR$(5) + CHR$(&H13)
 CASE ELSE
  Fehler$ = Fehler$ + "*Kanal ungltig"
END SELECT


SELECT CASE Bef$
 CASE "f", "u", "i", "e", "k", "t", "w", "a", "s", "h"
  'Funktionen ohne Parameter, keine weitere Formatierung noetig
 CASE "F", "U", "T", "A"
  'Befehle mit Ein-Byte-Parameter:
  ACKholen% = -1
  Par$ = CHR$(Par%)
  IF Par% = 2 THEN Par$ = CHR$(5) + CHR$(&H12)
  IF Par% = 3 THEN Par$ = CHR$(5) + CHR$(&H13)
  IF Par% = 5 THEN Par$ = CHR$(5) + CHR$(&H15)
 CASE "I", "E", "K"
  'Befehle mit Zwei-Byte-Parameter:
  ACKholen% = -1
  HiByte% = Par% \ 256
  LoByte% = Par% MOD 256
  Par$ = CHR$(HiByte%)
  IF HiByte% = 2 THEN Par$ = CHR$(5) + CHR$(&H12)
  IF HiByte% = 3 THEN Par$ = CHR$(5) + CHR$(&H13)
  IF HiByte% = 5 THEN Par$ = CHR$(5) + CHR$(&H15)
  Par2$ = CHR$(LoByte%)
  IF LoByte% = 2 THEN Par2$ = CHR$(5) + CHR$(&H12)
  IF LoByte% = 3 THEN Par2$ = CHR$(5) + CHR$(&H13)
  IF LoByte% = 5 THEN Par2$ = CHR$(5) + CHR$(&H15)
  Par$ = Par$ + Par2$
 CASE ELSE
  Fehler$ = Fehler$ + "*Befehl unbekannt"
  EXIT SUB
END SELECT

'Datenblock senden:
PRINT #5, CHR$(2) + Bef$ + Kan$ + Par$ + CHR$(3);

'Bei Befehlen ACKNOWLEDGE = CHR$(6) holen; 3 Versuche
IF ACKholen% THEN
 FOR j% = 1 TO 3
  IF ALCempf%(FehlerEmpf%) = 6 THEN EXIT FOR
  PRINT #5, CHR$(2) + Bef$ + Kan$ + Par$ + CHR$(3);
 NEXT
IF j% = 4 THEN Fehler$ = Fehler$ + "*Kein ACK f Bef " + Bef$ + LTRIM$(STR$(Kan%)) + STR$(Par%)

END IF

END SUB

SUB ALCsuchen (Zeichen%)
'oeffnet die seriellen Schnittstellen (COM1, COM2), sendet einen Befehl und
'wertet den Identifikations-String vom ALC7000 aus.

 DIM sik%(6)

 CLS
 PRINT
 COLOR 0, 7
 PRINT "ALC7t 1.26               www.FrankSteinberg.de                        >>fst'06<<"
 PRINT "Datenlogger fr das ALC 7000 Expert Ladegert von ELV-Elektronik    (www.elv.de)"
 COLOR 7, 0
 PRINT : PRINT

 FOR COMNr% = 1 TO 2
  BA% = BasisAdr%(COMNr%)
  IF BA% THEN
   PRINT USING "Suche an COM#, bitte warten ..."; COMNr%
   PRINT
   CALL RegSichern(BA%, sik%())
   CALL COMoeffnen
   PRINT #5, CHR$(2) + "v" + CHR$(3);
   CALL ALCText(Text$, Zeichen%)
   Text$ = RIGHT$(Text$, 7)
   IF Text$ = "ALC7000" THEN PRINT Text$; " gefunden": SLEEP 1: EXIT SUB
   CLOSE #5
   CALL RegRestaurieren(BA%, sik%())
  END IF
  PRINT
 NEXT

 IF Text$ <> "ALC7000" THEN PRINT Text$: END

END SUB

SUB ALCText (Text$, Zeichen%)
'empfaengt eine Zeichenkette vom ALC7000 und speichert sie in Text$:

 Zeichen% = 0: Text$ = ""
 TIMER ON
 DO
  IF LOC(5) THEN
   Byte$ = INPUT$(1, #5)
   Zeichen% = ASC(Byte$)
   IF Zeichen% > 32 THEN Text$ = Text$ + Byte$
  END IF
 LOOP UNTIL Zeichen% = 3
 TIMER OFF

END SUB

FUNCTION aNennKap
'Abruf der Nennkapazitaet

 DO
  CALL ALCsend("k", Kan%, 0)
  aNennKap = ALCempf%(FehlerEmpf%) / 100
 LOOP WHILE FehlerEmpf%

END FUNCTION

SUB AnzEinstell
'vom ALC7000 empfangene Einstellungen anzeigen

SELECT CASE Kan%
  CASE 1
   Spalte% = 31
  CASE 2
   Spalte% = 44
  CASE 3
   Spalte% = 57
  CASE 4
   Spalte% = 70
 END SELECT

 COLOR 7, 1

 'Alte Werte loeschen:
 FOR j% = 4 TO 11
  LOCATE j%, Spalte% - 1
  PRINT SPACE$(12)
 NEXT

 COLOR 12, 1
 LOCATE 4, Spalte%: PRINT "lesen ...";
 Programm$(Kan%) = aProgramm$
 COLOR 7, 1
 LOCATE 4, Spalte%: PRINT Programm$(Kan%);
 Akkutyp$(Kan%) = aAkkutyp$(UZelle)
 LOCATE 5, Spalte%: PRINT Akkutyp$(Kan%);
 AnzZellen%(Kan%) = aZellenzahl%
 LOCATE 6, Spalte%: PRINT USING "##"; AnzZellen%(Kan%);
 UNenn(Kan%) = AnzZellen%(Kan%) * UZelle
 LOCATE 7, Spalte%: PRINT USING "##.#    V"; UNenn(Kan%);
 CNenn(Kan%) = aNennKap
 LOCATE 8, Spalte%: PRINT USING "##.###  Ah"; CNenn(Kan%);
 ILad(Kan%) = aLadestrom
 LOCATE 9, Spalte%: PRINT USING " #.###  A"; ILad(Kan%);
 IEntl(Kan%) = aEntladestrom
 LOCATE 10, Spalte%: PRINT USING " #.###  A"; IEntl(Kan%);
 Tmp$ = EDatei$(Kan%) + "            "
 Tmp$ = LEFT$(EDatei$(Kan%), 12)
 LOCATE 11, Spalte% - 1: PRINT Tmp$;

END SUB

SUB AnzMesswerte
'vom ALC7000 empfangene Messwerte anzeigen

SELECT CASE Kan%
  CASE 1
   Spalte% = 31
  CASE 2
   Spalte% = 44
  CASE 3
   Spalte% = 57
  CASE 4
   Spalte% = 70
 END SELECT

 IF Beenden% = 0 THEN
 LOCATE 12, 30: COLOR 0, 7
 PRINT "                                                   ";
 LOCATE 12, Spalte%: PRINT " Messung!";
 END IF
 COLOR 14, 1
 LOCATE 16, Spalte%: PRINT USING "##.###  V"; UMess(Kan%);
 LOCATE 20, Spalte%: PRINT USING " #.###  A"; IMess(Kan%);
 LOCATE 21, Spalte%: PRINT tStromrichtg(IRichtg%(Kan%));
 LOCATE 23, Spalte%: PRINT USING "##.###  Ah"; CMess(Kan%); 'CEntl(Kan%);
 IF CFlag%(Kan%) THEN LOCATE 23, Spalte% + 7: PRINT "*";
 LOCATE 13, Spalte%: PRINT tStatus$(KanStatus%(Kan%));
 IF (AkStatus%(Kan%) > 1) AND (UMess(Kan%) > .05) THEN COLOR 26, 1
 LOCATE 14, Spalte%: PRINT tZustand$(AkStatus%(Kan%));

 COLOR 7, 1
 IF Aufz%(Kan%) = 2 THEN COLOR 0, 7
 LOCATE 15, Spalte%: PRINT " "; Zeit$(Seku(Kan%)); " ";
 COLOR 7, 1
 IF UMin(Kan%) < 99.9 THEN Tmp = UMin(Kan%)
 LOCATE 17, Spalte%: PRINT USING "##.###  V"; UMax(Kan%);
 LOCATE 18, Spalte%: PRINT USING "##.###  V"; UMin(Kan%);
 LOCATE 19, Spalte%: PRINT USING "##.###  V"; DP(Kan%);
 LOCATE 22, Spalte%: PRINT USING "##.###  Ah "; CLad(Kan%);
 COLOR 7, 1
 LOCATE 24, Spalte% - 1: PRINT MDatei$(Kan%);

 '3x ! anzeigen, bei Programmstopp wegen Kapazitaets-Grenzwert:
 IF CGrFlag%(Kan%) THEN
  LOCATE 13, Spalte% + 10: PRINT "!";
  LOCATE 14, Spalte% + 10: PRINT "!";
  LOCATE 22, Spalte% + 10: PRINT "!";
 END IF

 Fehler$ = RIGHT$(Fehler$, 80)
 STATIC FehlerAlt$
 IF Fehler$ <> FehlerAlt$ THEN SOUND 100, 4
 IF Taste$ = "" THEN Taste$ = UCASE$(INKEY$)
 FehlerAlt$ = Fehler$
 COLOR 0, 7: LOCATE 25, 1
 PRINT Fehler$;

 'LED-Imitation:
 COLOR 10, 1                              'Dauerlicht gruen
 IF AkStatus%(Kan%) > 1 THEN COLOR 26, 1  'blinkend, wenn voll/leer
 IF KanStatus%(Kan%) = 0 THEN COLOR 8, 1  'dunkel, wenn inaktiv
 LOCATE 13, Spalte%: PRINT "":

 'blinkende Doppelpunkte bei Zeitangabe:
 IF Aufz%(Kan%) = 2 THEN
  COLOR 16, 7
  LOCATE 15, Spalte% + 3: PRINT ":";
  LOCATE 15, Spalte% + 6: PRINT ":";
 END IF

 COLOR 7

END SUB

FUNCTION aProgramm$
'Abruf des eingestellten Ladeprogramms

 CALL ALCsend("f", Kan%, 0)

 DO
  SELECT CASE ALCempf%(FehlerEmpf%)
   CASE 0
    aProgramm$ = "Laden      "
   CASE 1
    aProgramm$ = "Entladen   "
   CASE 2
    aProgramm$ = "Entl./Laden"
   CASE 3
    aProgramm$ = "Test       "
   CASE 4
    aProgramm$ = "Zyklen     "
   CASE 5
    aProgramm$ = "Auffrischen"
   CASE ELSE
    aProgramm$ = "   ???     "
   END SELECT
 LOOP WHILE FehlerEmpf%

END FUNCTION

FUNCTION AuswahlAEI$
'Erstellt Dateiliste und ermoeglicht Auswahl ueber Pfeiltasten.

 COLOR 7, 1
 CLS

 FILES "*.aei"                         '** Dateien anzeigen

 IF SCREEN(1, 2) = 58 THEN             '** Kopf Zeile mit Pfad loeschen
  LOCATE 1, 1                          '   (wenn 2. Zeichen = ":")
  PRINT SPACE$(80);
 END IF

 FOR I% = 2 TO 23
  IF SCREEN(I%, 1) = 32 THEN            '*** Fusszeile suchen
   LOCATE I%, 1                         '    ... und loeschen
   PRINT SPACE$(80);
   EXIT FOR
  END IF
 NEXT

 x% = 1: Y% = 2

 DO
  Filn$ = ""                            '** Dateinamen aus Bild auslesen
  FOR I% = 0 TO 11
   Filn$ = Filn$ + CHR$(SCREEN(Y%, x% + I%))
  NEXT I%

  COLOR 0, 7: LOCATE Y%, x%
  PRINT Filn$                           '** Namen invers darstellen

  DO
   Key$ = INKEY$
  LOOP UNTIL LEN(Key$)                  '** auf Taste warten

  COLOR 7, 1: LOCATE Y%, x%
  PRINT Filn$                           '** Namen wieder normal darstellen

  SELECT CASE ASC(RIGHT$(Key$, 1))      '** Taste auswerten
   CASE 13, 27: EXIT DO                 '** <Return> oder <Escape>: Ende

   CASE 72                              '** Cursor hoch
    IF Y% > 1 THEN
     IF CHR$(SCREEN(Y% - 1, x%)) <> " " THEN Y% = Y% - 1
    END IF
   CASE 80                              '** Cursor runter
    IF CHR$(SCREEN(Y% + 1, x%)) <> " " THEN Y% = Y% + 1
   CASE 75                              '** Cursor links
    x% = x% + 18 * (x% > 1)
   CASE 77                              '** Cursor rechts
    IF CHR$(SCREEN(Y%, x% + 18)) <> " " THEN x% = x% + 18

   CASE ELSE
  END SELECT

 LOOP

 AuswahlAEI$ = RTRIM$(LEFT$(Filn$, 8))

END FUNCTION

FUNCTION aZellenzahl%
'Abruf der Zellenzahl

 DO
  CALL ALCsend("u", Kan%, 0)
  aZellenzahl% = ALCempf%(FehlerEmpf%)
 LOOP WHILE FehlerEmpf%

END FUNCTION

FUNCTION BasisAdr% (x%)
'I/O Basisadressen vom COM-Port aus BIOS-Datenbereich lesen

 DEF SEG = 0
 IF x% = 2 THEN
   BasisAdr% = PEEK(&H402) + PEEK(&H403) * 256
  ELSE
   BasisAdr% = PEEK(&H400) + PEEK(&H401) * 256
 END IF

END FUNCTION

SUB CGrenzwert
'Ueberprueft, ob der Kapazitaets-Grenzwert (= Nennkapazitaet+20%)
'beim Laden ueberschritten wird. Wenn ja, wird das Lade-Programm
'abgebrochen.

 IF Aufz%(Kan%) <> 2 THEN EXIT SUB           'nur, wenn Aufzeichnung laeuft
 IF IRichtg%(Kan%) <> 1 THEN EXIT SUB        'nur, bei "laden"
 IF Prog%(Kan%) = 5 THEN EXIT SUB            'nicht bei "Auffrischen"
 IF CLad(Kan%) < CLadGr(Kan%) THEN EXIT SUB  'nur, wenn Ladekap. zu gross
  CALL ALCsend("A", Kan%, 0)  'Kanal deaktivieren (Programm-Stopp)
  CGrFlag%(Kan%) = -1         'Indikator fuer C-Ueberschreitung
  KanStatus%(Kan%) = 0        'Kanal-Inaktiv suggerieren
  AkStatus%(Kan%) = 2         'Akku-Voll suggerieren
  Fehler$ = Fehler$ + "!Kap'Grenzwert K" + LTRIM$(STR$(Kan%)) + " erreicht!"

END SUB

SUB COMoeffnen

 CLOSE #5

 'Schnittstelle als Ein- und Ausgang oeffnen
 'mit 9600 Baud ohne Ueberpruefung der Statusleitungen:
 IF COMNr% = 2 THEN
  OPEN "COM2:9600,,,,CD,CS,DS,RS" FOR RANDOM AS #5
  OUT BA% + 3, 27        'gerade Paritaet, 8 Datenbits, 1 Stoppbit
 ELSE
  OPEN "COM1:9600,,,,CD,CS,DS,RS" FOR RANDOM AS #5
  OUT BA% + 3, 27        'gerade Paritaet, 8 Datenbits, 1 Stoppbit
 END IF

END SUB

SUB DateiKopf
'Kopfangaben in die Messdaten-Datei schreiben


 'Namen der Messdaten-Datei festlegen und drei alte Versionen behalten:
 CALL DateiStart

 OPEN MDatei$(Kan%) FOR OUTPUT AS #Kan%

 'Deutsches Datumsformat mit vierstelliger Jahreszahl erzeugen
 Datum$ = MID$(DATE$, 4, 2) + "." + LEFT$(DATE$, 2) + "." + RIGHT$(DATE$, 4)

 PRINT #Kan%, "; Messdaten-Datei des Programms ALC7t 1.26; angelegt " + Datum$ + ", " + TIME$ + " Uhr"
 PRINT #Kan%, ";"
 PRINT #Kan%, "; Beschreibung :"
 PRINT #Kan%, "; "; Beschreibung$(Kan%)
 PRINT #Kan%, ";"
 PRINT #Kan%, "; Einstellungen beim Start:"
 PRINT #Kan%, USING "; Kanal           #            Programm      "; Kan%;
 PRINT #Kan%, Programm$(Kan%)
 PRINT #Kan%, USING "; Zellenzahl     ##            Akkutyp       "; AnzZellen%(Kan%);
 PRINT #Kan%, Akkutyp$(Kan%)
 PRINT #Kan%, USING "; Nennspannung   ##.#   V      Ladestrom     #.### A"; UNenn(Kan%); ILad(Kan%)
 PRINT #Kan%, USING "; Nennkapazitaet  #.### Ah     Entladestrom  #.### A"; CNenn(Kan%); IEntl(Kan%)
 PRINT #Kan%, ";"
 PRINT #Kan%, "; Messwerte:"
 PRINT #Kan%, ";Zeit[Sek.]"; CHR$(9); "Spannung[V]"
 PRINT #Kan%, ";; Strom[A]";

END SUB

SUB DateiStart
'Namen der Messdaten-Datei festlegen und drei alte Versionen behalten

 'Messdaten-Datei hat den Namen 0_kanal?.amw (?=Kanalnummer)
 MDatei$(Kan%) = "0_kanal" + LTRIM$(STR$(Kan%)) + ".amw"

 '3 alte Versionen der Messdaten-Datei sichern (1_kanal?.amw - 3_kanal?.amw):
 IF DateiVorh%(MDatei$(Kan%)) THEN
  FOR j% = 3 TO 1 STEP -1
   DatAlt$ = LTRIM$(STR$(j%)) + "_kanal" + LTRIM$(STR$(Kan%)) + ".amw"
   DatNeu$ = LTRIM$(STR$(j% - 1)) + "_kanal" + LTRIM$(STR$(Kan%)) + ".amw"
   IF DateiVorh%(DatAlt$) THEN KILL DatAlt$
   IF DateiVorh%(DatNeu$) THEN NAME DatNeu$ AS DatAlt$
  NEXT
 END IF

END SUB

FUNCTION DateiVorh% (DName$)
'Pruefung, ob Datei vorhanden (-1, wenn ja)

 x% = FREEFILE
 OPEN DName$ FOR APPEND AS #x%
 IF LOF(x%) THEN Tmp% = -1
 CLOSE #x%
 IF Tmp% = 0 THEN KILL DName$
 DateiVorh% = Tmp%

END FUNCTION

SUB DeltaPeak
'Delta-Peak-Wert beim Laden berechnen

 IF (IRichtg%(Kan%) = 1) AND (Aufz%(Kan%) = 2) THEN
  IF UMess(Kan%) <= DPMax(Kan%) THEN DP(Kan%) = DPMax(Kan%) - UMess(Kan%)
 END IF

END SUB

SUB DOS
'DOS-Eingabeaufforderung starten:

 'offene Messdatendateien zwischenspeichern
 IF Aufz%(1) = 2 THEN CLOSE #1: OPEN "0_kanal1.amw" FOR APPEND AS #1
 IF Aufz%(2) = 2 THEN CLOSE #2: OPEN "0_kanal2.amw" FOR APPEND AS #2
 IF Aufz%(3) = 2 THEN CLOSE #3: OPEN "0_kanal3.amw" FOR APPEND AS #3
 IF Aufz%(4) = 2 THEN CLOSE #4: OPEN "0_kanal4.amw" FOR APPEND AS #4

 PCOPY 0, 1
 COLOR 7, 0: CLS : COLOR 0, 7
 LOCATE , 14: PRINT "  ALC7t unterbrochen; EXIT eingeben um fortzusetzen!  "
 COLOR 7, 0
 IF DateiVorh%("alcbatch.bat") THEN
   SHELL "command /C alcbatch.bat"
  ELSE
   SHELL "command"
 END IF
 PCOPY 1, 0
 CALL COMoeffnen   'der SHELL-Befehl schliesst die serielle Schnittstelle !?

END SUB

SUB Einstellungen
'Einstellungsdatei in Editor lesen, auf Plausibilitaet testen, an ALC7000
'senden, anschliessend lesen und anzeigen


 SELECT CASE Kan%
  CASE 1
   Standard$ = "kanal1.aei"
   Spalte% = 31
  CASE 2
   Standard$ = "kanal2.aei"
   Spalte% = 44
  CASE 3
   Standard$ = "kanal3.aei"
   Spalte% = 57
  CASE 4
   Standard$ = "kanal4.aei"
   Spalte% = 70
 END SELECT

 PCOPY 0, 1  'Bildschirm retten
 EDatei$(Kan%) = Praefix$ + ".aei"  'FUNCTION Praefix = Eingabefenster
 IF EDatei$(Kan%) = "x.aei" THEN PCOPY 1, 0: EXIT SUB  'Abbruch
 IF EDatei$(Kan%) = "a.aei" THEN      'Dateiliste gewaehlt
  OPEN "kanal1.aei" FOR APPEND AS #6  'Eine passende Datei muss
  IF LOF(6) < 1 THEN CALL StrukturAEI ' vorhanden sein!
  CLOSE #6
  EDatei$(Kan%) = LCASE$(AuswahlAEI$) + ".aei" 'FUNCTION AuswahlAEI$ = Liste
 END IF

 IF EDatei$(Kan%) = ".aei" THEN EDatei$(Kan%) = Standard$
 COLOR 0, 7: LOCATE 14, 36: PRINT EDatei$(Kan%); SPACE$(8);

 OPEN EDatei$(Kan%) FOR APPEND AS #6
 IF LOF(6) < 1 THEN CALL StrukturAEI
 CLOSE #6

 IF DateiVorh%("e.exe") THEN
   SHELL "e.exe " + EDatei$(Kan%)
  ELSEIF DateiVorh%("ex.com") THEN
   SHELL "ex.com " + EDatei$(Kan%)
  ELSE
   SHELL "edit " + EDatei$(Kan%)
 END IF
 PCOPY 1, 0

 CALL COMoeffnen   'der SHELL-Befehl schliesst die serielle Schnittstelle !?

 LOCATE 12, 30: COLOR 0
 PRINT "Einstellungen werden aktualisiert. Bitte warten ...";

 'Alte Werte loeschen:
 FOR j% = 4 TO 11
  LOCATE j%, Spalte% - 1
  COLOR 7, 1
  PRINT SPACE$(12)
 NEXT j%

 COLOR 12, 1
 LOCATE 4, Spalte%: PRINT "prfen ...";

 OPEN EDatei$(Kan%) FOR INPUT AS #6

 j% = 0
 DO UNTIL EOF(6)
  LINE INPUT #6, Zeile$
  Zeile$ = LTRIM$(Zeile$)
  IF LEFT$(Zeile$, 1) <> ";" THEN
   j% = j% + 1
   IF j% = 1 THEN Prog%(Kan%) = VAL(Zeile$)        'Programm
   IF j% = 2 THEN AnzZellen%(Kan%) = VAL(Zeile$)   'Zellenzahl
   IF j% = 3 THEN CNenn(Kan%) = VAL(Zeile$)        'Nennkapazitaet
   IF j% = 4 THEN ILad(Kan%) = VAL(Zeile$)         'Ladestrom
   IF j% = 5 THEN IEntl(Kan%) = VAL(Zeile$)        'Entladestrom
   IF j% = 6 THEN AKTyp%(Kan%) = VAL(Zeile$)       'Akkutyp
   IF j% = 7 THEN Beschreibung$(Kan%) = Zeile$     'Beschreibung
  END IF
 LOOP
 CLOSE #6


 'Fehleingaben beim Akkutyp berichtigen (dann NiCd/NiMH):
 IF (AKTyp%(Kan%) < 0) OR (AKTyp%(Kan%) > 1) THEN
  AKTyp%(Kan%) = 0
  Fehler$ = Fehler$ + "!Akkutyp K" + LTRIM$(STR$(Kan%)) + " prfen!       "
 END IF

 'Fehleingaben bei Programmwahl berichtigen (dann LADEN):
 IF (Prog%(Kan%) < 0) OR (Prog%(Kan%) > 5) THEN
  Prog%(Kan%) = 0
  Fehler$ = Fehler$ + "!Programm K" + LTRIM$(STR$(Kan%)) + " prfen!      "
 END IF

 'Fehleingaben bei Zellenzahl berichtigen (dann maximale Anzahl):
 IF (Kan% = 1) OR (Kan% = 2) THEN
  IF (AnzZellen%(Kan%) < 1) OR (AnzZellen%(Kan%) > 20) THEN AnzZellen%(Kan%) = 20: FFlag% = -1
  IF (AnzZellen%(Kan%) > 12) AND (AKTyp%(Kan%) = 1) THEN AnzZellen%(Kan%) = 12: FFlag% = -1
 ELSE
  IF (AnzZellen%(Kan%) < 1) OR (AnzZellen%(Kan%) > 10) THEN AnzZellen%(Kan%) = 10: FFlag% = -1
  IF (AnzZellen%(Kan%) > 6) AND (AKTyp%(Kan%) = 1) THEN AnzZellen%(Kan%) = 6: FFlag% = -1
 END IF
 'Zellenzahl mit gemessener Spannung vergleichen:
 IF AKTyp%(Kan%) = 0 THEN ZellSpannung = 1.6 ELSE ZellSpannung = 2.4
 IF UMess(Kan%) = 0 THEN CALL ALCsend("w", Kan%, 0): CALL ALCmess  'Messwerte abrufen
 IF UMess(Kan%) > (ZellSpannung * AnzZellen%(Kan%)) THEN
  AnzZellen%(Kan%) = UMess(Kan%) / (ZellSpannung - .4)
  FFlag% = -1
 END IF
 IF FFlag% THEN Fehler$ = Fehler$ + "!Zellenzahl K" + LTRIM$(STR$(Kan%)) + " prfen!    "

'Fehleingaben bei Nennkapazitaet berichtigen:
 IF (CNenn(Kan%) < .01) THEN
  CNenn(Kan%) = .01
  Fehler$ = Fehler$ + "!Nennkapaz. K" + LTRIM$(STR$(Kan%)) + " prfen!    "
 END IF
 IF (CNenn(Kan%) > 99.99) THEN
  CNenn(Kan%) = 99.99
  Fehler$ = Fehler$ + "!Nennkapaz. K" + LTRIM$(STR$(Kan%)) + " prfen!    "
 END IF

 'Grenzwert der Ladekapazitaet berechnen (Programmstopp bei Ueberschreitung):
 CLadGr(Kan%) = CNenn(Kan%) + CNenn(Kan%) * .2  'Nennkap. + 20%

 'Maximalen akkuabhaengigen Ladestrom (2C) berechnen:
 IMax = CNenn(Kan%) * 2
 IF ILad(Kan%) > IMax THEN
  ILad(Kan%) = IMax
  Fehler$ = Fehler$ + "!Ladestrom K" + LTRIM$(STR$(Kan%)) + " korrigiert! "
 END IF

 'Maximalen geraetbedingten Lade-/Entladestrom Kan.3/4 berechnen:
 '(die maximale Ladestrom-Summe der Kanaele 3/4 (1A) wird anschliessend
 'in der SUB KorrI34 berechnet und korrigiert).
 IF (Kan% = 3) OR (Kan% = 4) THEN
  'Ladeleistung:
  IF ILad(Kan%) > 1.0004 THEN
   ILad(Kan%) = 1
   FehlerLL% = -1
  END IF
 'Entladeleistung:
  IF IEntl(Kan%) > 1.0004 THEN
   IEntl(Kan%) = 1
   Fehler$ = Fehler$ + "!Entladeleist. K" + LTRIM$(STR$(Kan%)) + " korrig.!"
  END IF
 END IF

 CALL KorrI34(FehlerLL%)
 IF FehlerLL% THEN Fehler$ = Fehler$ + "!Ladeleist. K" + LTRIM$(STR$(Kan%)) + " korrigiert!"

 'Maximalen geraetbedingten Lade-/Entladestrom (Kanal 1/2, 28,8 W) berechnen:
 IF (Kan% = 1) OR (Kan% = 2) THEN
  IF AKTyp%(Kan%) = 0 THEN Y = 1.2 ELSE Y = 2  'Spannung pro Zelle
  Y = AnzZellen%(Kan%) * Y                     'Nennspannung Akku
  IF Y THEN IMax = (28.8 / Y) + .0004          'MaxStrom bei 28,8 Watt
  IF IMax > 3.5 THEN IMax = 3.5                '... sonst macht ALC 0.000A
  'Ladeleistung:
  IF ILad(Kan%) > IMax THEN
   ILad(Kan%) = IMax                          'Strom auf Max, wenn zu hoch
   Fehler$ = Fehler$ + "!Ladeleist. K" + LTRIM$(STR$(Kan%)) + " korrigiert!"
  END IF
  'Entladeleistung:
  IF IEntl(Kan%) > IMax THEN
   IEntl(Kan%) = IMax                          'Strom auf Max, wenn zu hoch
   Fehler$ = Fehler$ + "!Entladeleist. K" + LTRIM$(STR$(Kan%)) + " korrig.!"
  END IF
 END IF

 LOCATE 4, Spalte%: PRINT "senden ... ";
 
 '* Programm senden:
 x& = Prog%(Kan%)
 IF (x& > 0) AND (x& < 6) THEN Wert% = x& ELSE Wert% = 0
 CALL ALCsend("F", Kan%, Wert%)
 '* Akkutyp senden:
 x& = AKTyp%(Kan%)
 IF (x& > 0) AND (x& < 2) THEN Wert% = x& ELSE Wert% = 0
 CALL ALCsend("T", Kan%, AKTyp%(Kan%))
 '* Nennkapazitaet senden:
 x& = CNenn(Kan%) * 100
 IF (x& > 0) AND (x& < 10000) THEN Wert% = x& ELSE Wert% = 0
 CALL ALCsend("K", Kan%, Wert%)
 '* Zellenzahl senden:
 x& = AnzZellen%(Kan%)
 IF (x& > 0) AND (x& < 21) THEN Wert% = x& ELSE Wert% = 1
 CALL ALCsend("U", Kan%, Wert%)
 '* Ladestrom senden:
 x& = ILad(Kan%) * 1000
 IF (x& > 0) AND (x& < 3501) THEN Wert% = x& ELSE Wert% = 0
 CALL ALCsend("I", Kan%, Wert%)
 '* Entladestrom senden:
 x& = IEntl(Kan%) * 1000
 IF (x& > 0) AND (x& < 3501) THEN Wert% = x& ELSE Wert% = 0
 CALL ALCsend("E", Kan%, Wert%)

 SLEEP 3            'Wartezeit, sonst Fehlauslesung
 CALL AnzEinstell   'Werte anzeigen

 'Stromwerte berechnen, bei der die Aufzeichnung gestartet wird:
 IStart(Kan%) = IEntl(Kan%)
 IF ILad(Kan%) < IEntl(Kan%) THEN IStart(Kan%) = ILad(Kan%)
 IStart(Kan%) = IStart(Kan%) / 10
 IF IStart(Kan%) = 0 THEN IStart(Kan%) = .009

 'Kanal aktivieren;
 IF (ILad(Kan%) < .001) AND (Prog%(Kan%) <> 1) THEN
   CALL ALCsend("A", Kan%, 0)
   Fehler$ = Fehler$ + "!Kein Start K" + LTRIM$(STR$(Kan%)) + " Ladestr.=0!"
  ELSE
   CALL ALCsend("A", Kan%, 1)
 END IF

 IF Aufz%(Kan%) = 0 THEN Aufz%(Kan%) = 1   'Indikator: Einstellungen neu

END SUB

SUB Ende
'Routinen zum Beenden des Programms

 'Fussdaten in Messdateien schreiben:
 FOR j% = 1 TO 4
  Kan% = j%
  IF Aufz%(Kan%) = 2 THEN ProgrammEnde
 NEXT

 SOUND 4000, 2                'Ton
 CLOSE #5                     'Schnittstelle schliessen
 COLOR 7, 0                   'Normalschrift
 LOCATE 25, 1                 'Cursor in letzte Zeile
 PRINT SPACE$(80): PRINT      'Leerzeilen erzeugen
 END                          'das war's

END SUB

SUB EndeAbfrage
'Abfrage, ob beendet werden soll (Programm laeuft weiter)


 SOUND 4000, 1
 COLOR 0, 7
 LOCATE 12, 30
 PRINT "        Programm beenden ?  [J]a / [N]ein         ";
 COLOR 7, 1
 Beenden% = 1
 IF Taste$ = "J" THEN CALL Ende
 IF Taste$ = "N" THEN
  LOCATE , 30
  COLOR 0, 7
  PRINT "                                                  ";
  COLOR 7, 1
  Beenden% = 0
  Taste$ = ""
 END IF

 IF Taste$ = CHR$(27) THEN Taste$ = ""

END SUB

SUB FehlerSer
'Behandlung von Fehlern (seriell und andere - ON ERROR)

  COLOR 0, 7
  LOCATE 12, 30
  IF Beenden% = 0 THEN PRINT "    !!!      Kein Empfang vom ALC 7000      !!!   ";
  CALL COMoeffnen
  'LOCATE 25, 1: IF Taste$ = "" THEN PRINT "  ";  ELSE PRINT Taste$;
  SOUND 100, 4
  IF Taste$ = CHR$(27) THEN CALL EndeAbfrage
  IF Taste$ = "" THEN Taste$ = UCASE$(INKEY$)
  IF Beenden% = 1 THEN CALL EndeAbfrage

END SUB

SUB IRichtgNeu
'Routinen, wenn sich die Stromrichtung aendert

 IF IRichtg%(Kan%) = IRichtgAlt%(Kan%) THEN EXIT SUB
 IF Aufz%(Kan%) <> 2 THEN EXIT SUB

 SOUND 4000, 2

  'wenn Laden -> Entladen:
  IF IRichtgAlt%(Kan%) = 1 THEN
   CEntl(Kan%) = 0
   CEntlAlt(Kan%) = 0
   CFlag%(Kan%) = 0
   PRINT #Kan%, CHR$(9);
   PRINT #Kan%, USING "umgeschaltet auf ENTLADEN - geladen ##.### Ah, DeltaPeak##.### V"; CLad(Kan%); DP(Kan%);
  END IF
 
  'wenn Entladen -> Laden:
  IF IRichtgAlt%(Kan%) = 2 THEN
   CLad(Kan%) = 0
   DP(Kan%) = 0
   DPMax(Kan%) = 0
   PRINT #Kan%, CHR$(9);
   PRINT #Kan%, USING "umgeschaltet auf LADEN - entladen ##.### Ah"; CMess(Kan%);
  END IF

 'bei jeder Aenderung der Stromrichtung:
  'UMin(Kan%) = 99.999
  'UMax(Kan%) = 0

  'Messdatendatei zwischenspeichern:
  CLOSE #Kan%
  OPEN MDatei$(Kan%) FOR APPEND AS #Kan%

END SUB

SUB KanInit
'Zuruecksetzen aller Werte fuer Neustart einer Aufzeichnung

  'nix aendern, wenn Einstellmenue abgebrochen:
  IF EDatei$(Kan%) = "x.aei" THEN EXIT SUB

  CALL ALCsend("A", Kan%, 0)
  UMin(Kan%) = 99.999
  UMax(Kan%) = 0
  DP(Kan%) = 0
  DPMax(Kan%) = 0
  CLad(Kan%) = 0
  CGrFlag%(Kan%) = 0
  CEntl(Kan%) = 0
  CEntlAlt(Kan%) = 0
  CFlag%(Kan%) = 0
  IRichtgAlt%(Kan%) = 0
  Seku(Kan%) = 0
  SekuAlt(Kan%) = 0
  TStart(Kan%) = 0
  TAlt(Kan%) = 0
  Tage&(Kan%) = 0

END SUB

SUB KanISTTaste
'aktuelle Kanalnummer durch gedrueckte Taste ersetzen

SELECT CASE Taste$
  CASE "1", "!"
   Kan% = 1
  CASE "2", CHR$(34)
   Kan% = 2
  CASE "3", CHR$(21), CHR$(245)
   Kan% = 3
  CASE "4", "$"
   Kan% = 4
 END SELECT

 Taste$ = ""

END SUB

SUB Kapazitaet
'eingeladenen und entladene Kapazitaet seit letztem Aufruf errechnen
'und aufaddieren

 Intervall = Seku(Kan%) - SekuAlt(Kan%)

 'Lade-Kapazitaet aufaddieren:
 IF (IRichtg%(Kan%) = 1) AND (Aufz%(Kan%) = 2) THEN
  CLad(Kan%) = CLad(Kan%) + IMess(Kan%) * Intervall / 3600 * .975
 END IF
 
 'Entlade-Kapazitaet aufaddieren:
 IF (IRichtg%(Kan%) = 2) AND (Aufz%(Kan%) = 2) THEN
  CEntl(Kan%) = CEntl(Kan%) + IMess(Kan%) * Intervall / 3600 * .975
 END IF

 'Wenn Enladekapazitaet vom ALC geloescht wird (bei Ueberhitzung),
 'soll die errechnete benutzt werden:
 IF IRichtg%(Kan%) = 2 THEN
  IF CMess(Kan%) < CMessAlt(Kan%) THEN CFlag%(Kan%) = -1
  CMessAlt(Kan%) = CMess(Kan%)
 END IF

 IF CFlag%(Kan%) THEN CMess(Kan%) = CEntl(Kan%)

 SekuAlt(Kan%) = Seku(Kan%)

END SUB

SUB KorrI34 (FehlerLL%)

'Kanal 3 pruefen:
IF Kan% = 3 THEN
  IF Prog%(3) = 1 THEN EXIT SUB                 'o.k. wenn Kan3 auf Entladen
  CALL ALCsend("a", 4, 0)
  KanStatus%(4) = ALCempf%(Dummy%)
  IF KanStatus%(4) = 0 THEN GOTO inaktiv        'o.k. wenn Kan4 inaktiv
  CALL ALCsend("s", 4, 0)
  AkStatus%(4) = ALCempf%(Dummy%)
  IF AkStatus%(4) > 1 THEN EXIT SUB             'o.k. wenn Akku Kan4 voll
  CALL ALCsend("f", 4, 0)
  Prog%(4) = ALCempf%(Dummy%)
  IF Prog%(4) = 1 THEN EXIT SUB                 'o.k. wenn Kan4 auf Entladen
  CALL ALCsend("i", 4, 0)
  ILad!(4) = ALCempf%(Dummy%) / 1000
  IF ILad!(3) + ILad!(4) < 1.0004 THEN
    EXIT SUB                                    'o.k. wenn Strom unter 1A
   ELSE
    ILad!(3) = 1 - ILad!(4)                     '... sonst reduzieren
    FehlerLL% = -1
  END IF
END IF

'Kanal 4 pruefen:
IF Kan% = 4 THEN
  IF Prog%(4) = 1 THEN EXIT SUB                 'o.k. wenn Kan4 auf Entladen
  CALL ALCsend("a", 3, 0)
  KanStatus%(3) = ALCempf%(Dummy%)
  IF KanStatus%(3) = 0 THEN GOTO inaktiv        'o.k. wenn Kan3 inaktiv
  CALL ALCsend("s", 3, 0)
  AkStatus%(3) = ALCempf%(Dummy%)
  IF AkStatus%(3) > 1 THEN EXIT SUB             'o.k. wenn Akku Kan3 voll
  CALL ALCsend("f", 3, 0)
  Prog%(3) = ALCempf%(Dummy%)
  IF Prog%(3) = 1 THEN EXIT SUB                 'o.k. wenn Kan3 auf Entladen
  CALL ALCsend("i", 3, 0)
  ILad!(3) = ALCempf%(Dummy%) / 1000
  IF ILad!(3) + ILad!(4) < 1.0004 THEN
    EXIT SUB                                    'o.k. wenn Strom unter 1A
   ELSE
    ILad!(4) = 1 - ILad!(3)                     '... sonst reduzieren
    FehlerLL% = -1
  END IF
END IF

EXIT SUB

inaktiv:
EXIT SUB

 'Ladestrom des inaktiven Kanals ggf. senken (Schutz bei manuellem Start):

 IF Kan% = 3 THEN
  CALL ALCsend("i", 4, 0)
  ILad!(4) = ALCempf%(Dummy%) / 1000
  IF ILad!(3) + ILad!(4) > 1.0004 THEN
   ILad!(4) = 1 - ILad!(3)
   Tmp% = ILad!(4) * 1000
   CALL ALCsend("I", 4, Tmp%)
  END IF
 END IF

 IF Kan% = 4 THEN
  CALL ALCsend("i", 3, 0)
  ILad!(3) = ALCempf%(Dummy%) / 1000
  IF ILad!(3) + ILad!(4) > 1.0004 THEN
   ILad!(3) = 1 - ILad!(4)
   Tmp% = ILad!(3) * 1000
   CALL ALCsend("I", 3, Tmp%)

  END IF
 END IF

END SUB

SUB Maske (Version$)
'Hintergrundbildschirm erzeugen

COLOR 7, 1
CLS
COLOR 0, 7
PRINT " ALC7t 1.26   *   Datenlogger fr Ladegert  -ALC7000 Expert-   *    >>fst'06<< ";
COLOR 7, 1
PRINT " Gertesoftware "; Version$; "     Programm beenden mit [Esc]     www.FrankSteinberg.de ";
COLOR 0, 7
PRINT "E i n s t e l l u n g e n      Kanal  1     Kanal  2     Kanal  3     Kanal  4  ";
COLOR 7, 1
PRINT "Programm"
PRINT "Akkutyp                       ndern mit   ndern mit   ndern mit   ndern mit"
PRINT "Zellenzahl                    Taste  [1]   Taste  [2]   Taste  [3]   Taste  [4]"
PRINT "Nennspannung"
PRINT "Nennkapazitt                  Neustart     Neustart     Neustart     Neustart"
PRINT "Ladestrom                     [Shift+ 1]   [Shift+ 2]   [Shift+ 3]   [Shift+ 4]"
PRINT "Entladestrom"
PRINT "Konfigurationsdatei"
COLOR 0, 7
PRINT "M e s s w e r t e             lesen ...                                         ";
COLOR 7, 1
PRINT "Kanal-Status"
PRINT "Akku-Status"
PRINT "Dauer der Aufzeichnung"
PRINT "Aktuelle Spannung"
PRINT "Maximalspannung"
PRINT "Minimalspannung"
PRINT "Delta-Peak letzes Laden"
PRINT "Aktueller Strom"
PRINT "Stromrichtung"
PRINT "Letzte geladene  Kapazitt"
PRINT "Letzte entladene Kapazitt"
PRINT "Messwertedatei";
COLOR 0, 7
LOCATE 25, 1
PRINT "                                                                                ";

FOR j% = 3 TO 24
 FOR k% = 29 TO 80 STEP 13
  LOCATE j%, k%: PRINT " ";
 NEXT
NEXT

END SUB

FUNCTION Praefix$
'Praefix des Namens der Einstellungsdatei abfragen

 CONST Z% = 8
 CONST S% = 20

 PCOPY 0, 1
 COLOR 0, 7
 LOCATE Z%, S%: PRINT " Ŀ "
   LOCATE , S%: PRINT "               K a n a l   X              "
   LOCATE , S%: PRINT "                                          "
   LOCATE , S%: PRINT "                                          "
   LOCATE , S%: PRINT "     Dateinamen fr Einstellungsdatei     "
   LOCATE , S%: PRINT "       eingeben (maximal 8 Zeichen)       "
   LOCATE , S%: PRINT "               XXXXXXXX.aei               "
   LOCATE , S%: PRINT "                                          "
   LOCATE , S%: PRINT "  [Enter] ohne Eingabe fr Standarddatei  "
   LOCATE , S%: PRINT "           [a]+[Enter] fr Dateiliste     "
   LOCATE , S%: PRINT "           [x]+[Enter] fr Abbruch        "
   LOCATE , S%: PRINT "  "

 COLOR 1
 LOCATE Z% + 1, S% + 27: PRINT Kan%;
 LOCATE Z% + 2, S% + 3: PRINT Fenstertext$;
 COLOR 0
 LOCATE Z% + 6, S% + 16: COLOR 7, 0: PRINT SPACE$(8);

 LOCATE Z% + 6, Z% + 28: LINE INPUT "", x$

 Verboten$ = CHR$(34) + ",./:;<=>[\]|"
 FOR I% = 1 TO LEN(x$)
  Zeichen$ = MID$(x$, I%, 1)
  IF (ASC(Zeichen$) < 33) OR (ASC(Zeichen$) > 127) THEN Zeichen$ = ""
  IF INSTR(Verboten$, Zeichen$) THEN Zeichen$ = ""
  Tmp$ = Tmp$ + Zeichen$
 NEXT
 Praefix$ = LCASE$(LEFT$(Tmp$, 8))

END FUNCTION

SUB ProgrammEnde
'Fuss-Daten in Messdaten-Datei schreiben und schliessen
 
 PRINT #Kan%, : PRINT #Kan%, ";"
 IF CGrFlag%(Kan%) THEN
  PRINT #Kan%, USING "; ABBRUCH: Ladekapazitaets-Grenzwert (##.### Ah) erreicht."; CLadGr(Kan%)
 END IF
 PRINT #Kan%, ";"
 PRINT #Kan%, USING "; zuletzt geladen     ##.### Ah"; CLad(Kan%)
 PRINT #Kan%, USING "; zuletzt entladen    ##.### Ah"; CMess(Kan%)
 PRINT #Kan%, USING "; Maximalspannung     ##.### V"; UMax(Kan%)
 PRINT #Kan%, USING "; Minimalspannung     ##.### V"; UMin(Kan%)
 PRINT #Kan%, USING "; Delta-Peak-Spannung ##.### V"; DP(Kan%)
       PRINT #Kan%, "; Laufzeit             "; Zeit$(Seku(Kan%));

 CLOSE #Kan%
 Aufz%(Kan%) = 0  'Indikator: keine Aufzeichnung mehr
 SOUND 4000, 2

END SUB

SUB RegRestaurieren (BA%, sik%())
'Register (=Einstellungen) der nicht vom ALC7000 genutzten
'seriellen Schnittstelle wieder herstellen

 'Bit7 (Wert 128) im LSR aktiviert Baudrateneingabe:
 OUT BA% + 3, sik%(3) OR 128
 sik%(0) = INP(&H21)
 OUT BA% + 0, sik%(5)
 OUT BA% + 1, sik%(6)
 OUT BA% + 3, sik%(3) AND 127

 'Bits 4-7 vom Modem-Steuerregister duerfen nicht veraendert werden,
 'sonst Windows-Absturz
 sik%(4) = sik%(4) AND 15    'Bit4-7 der Sicherung loeschen
 in% = INP(BA% + 4) AND 240  'Bit0-3 des aktuellen Registerinhalts loeschen
 OUT BA% + 4, sik%(4) + in%  'zusammengesetzten Wert ausgeben
 OUT BA% + 3, sik%(3)
 OUT BA% + 1, sik%(1)

END SUB

SUB RegSichern (BA%, sik%())
'Register (=Einstellungen) der seriellen Schnittstelle sichern

 sik%(1) = INP(BA% + 1)
 sik%(3) = INP(BA% + 3)
 sik%(4) = INP(BA% + 4)

 'Bit7 (Wert 128) im LSR aktiviert Baudrateneingabe:
 OUT BA% + 3, sik%(3) OR 128
 sik%(0) = INP(&H21)
 sik%(5) = INP(BA% + 0)
 sik%(6) = INP(BA% + 1)
 OUT BA% + 3, sik%(3) AND 127

END SUB

SUB StrukturAEI
'Legt eine Musterdatei an, wenn keine Einstellungsdatei vorhanden

PRINT #6, ";Konfigurationsdatei ALC7t V1.26; Datenlogger fuer Ladegeraet -ALC7000 Expert-"
PRINT #6, "; - Zeilen, die mit einem Semikolon beginnen, werden ignoriert."
PRINT #6, "; - DezimalPUNKT statt Komma verwenden!"
PRINT #6, ";"
PRINT #6, "; 1.Programm   0=Laden  1=Entl. 2=Entl-Laden  3=Test  4=Zyklen  5=Auffrischen"
PRINT #6, "0"
PRINT #6, "; 2.Zellenzahl [Anzahl]    gueltige Werte = 1-20"
PRINT #6, "8"
PRINT #6, "; 3.Nennkapazitaet [Ah]    gueltige Werte = 0.010-99.990  Aufloesung 0.01"
PRINT #6, "0.1"
PRINT #6, "; 4.Ladestrom [A]          gueltige Werte = 0.000-3.500   Aufloesung 0.001"
PRINT #6, ";                          (maximaler Wert 2x Nennkapazitaet = 2C)"
PRINT #6, "0.0"
PRINT #6, "; 5.Entladestrom [A]       gueltige Werte = 0.000-3.500   Aufloesung 0.001"
PRINT #6, "0.0"
PRINT #6, "; 6.Akkutyp    0=NiCd/NiMH-Akku   1=Bleiakku"
PRINT #6, "0"
PRINT #6, "; 7.Beschreibung (eine Zeile beliebiger Text; erscheint in der Messdatendatei)"
PRINT #6, "Diesen Text durch eine Beschreibung des Akkus ersetzen";

END SUB

FUNCTION Tmr
'Sekunden seit Mitternacht ausgeben
' bei Rechnern mit Power-Management (Handy-Organizer) funktioniert
' bei laengerer Programm-Inaktivitaet die Basic-eigene TIMER-Funktion
' nicht zuverlaessig.

 DEF SEG = 0
 C = PEEK(&H46C)
 D& = PEEK(&H46D)
 E& = PEEK(&H46E)
 Tmp& = C + D& * 256 + E& * 65536
 Tmr = Tmp& / 18.2065

END FUNCTION

FUNCTION tStatus$ (x%)
'Textanzeige fuer den Kanalstatus erzeugen

 SELECT CASE x%
  CASE 0
   tStatus$ = "  inaktiv  "
  CASE 1
   tStatus$ = "  aktiv    "
  CASE ELSE
   tStatus$ = "   ???     "
  END SELECT

END FUNCTION

FUNCTION tStromrichtg$ (x%)
'Textanzeige der Stromrichtung erzeugen

 SELECT CASE x%
  CASE 1
   tStromrichtg$ = " laden    "
  CASE 2
   tStromrichtg$ = " entladen "
  CASE ELSE
   tStromrichtg$ = "   ?" + LTRIM$(STR$(x%)) + "?    "
  END SELECT

END FUNCTION

FUNCTION tZustand$ (x%)
'Textanzeige des Akkustatus erzeugen

 SELECT CASE x%
  CASE 0
   tZustand$ = "kein Akku  "
  CASE 1
   tZustand$ = "Akku ang.  "
  CASE 2
   tZustand$ = "Akku voll  "
  CASE 3
   tZustand$ = "Akku leer  "
  CASE ELSE
   tZustand$ = "    ???    "
  END SELECT

END FUNCTION

SUB UMinMax
'Minimal-/Maximalspannung festhalten

 'Minimalspannung berechnen, sobald eine Spannung gemessen wird:
 IF UMess(Kan%) THEN
  IF UMess(Kan%) < UMin(Kan%) THEN UMin(Kan%) = UMess(Kan%)
 END IF

 'Maximalspannung berechnen:
 IF UMess(Kan%) > UMax(Kan%) THEN UMax(Kan%) = UMess(Kan%)
 IF UMess(Kan%) > DPMax(Kan%) THEN DPMax(Kan%) = UMess(Kan%)

END SUB

SUB warte (Ticks%)
'Wartezeit erzeugen

 DEF SEG = 0
 FOR j% = 1 TO Ticks%
  t% = PEEK(&H46C)
  DO: LOOP WHILE t% = PEEK(&H46C)
 NEXT

END SUB

SUB WertInDatei
'einen Messwert in die Messwerte-Datei schreiben

 IF IRichtg%(Kan%) <> IRichtgAlt%(Kan%) THEN EXIT SUB
 IF AkStatus%(Kan%) > 1 THEN EXIT SUB
 IF Aufz%(Kan%) <> 2 THEN EXIT SUB

 Tmp& = Seku(Kan%)
 PRINT #Kan%,
 PRINT #Kan%, LTRIM$(STR$(Tmp&)); CHR$(9); LTRIM$(STR$(UMess(Kan%)))
 PRINT #Kan%, ";;"; LTRIM$(STR$(IMess(Kan%)));

END SUB

FUNCTION Zeit$ (Sekux)
'aus Sekunden -> Stunden:Minuten:Sekunden machen

Stunden& = Sekux \ 3600
RestSeku& = Sekux - Stunden& * 3600
Minuten% = RestSeku& \ 60
RestSeku& = RestSeku& - Minuten% * 60
Sekunden% = RestSeku&

'String erzeugen
'fuehrende Nullen und Doppelpunkt ergaenzen
IF Stunden& > 9 THEN
  Tmp$ = RIGHT$(STR$(Stunden&), 2)
 ELSE
  Tmp$ = "0" + RIGHT$(STR$(Stunden&), 1)
END IF
 Tmp$ = Tmp$ + ":"
IF Minuten% > 9 THEN
  Tmp$ = Tmp$ + RIGHT$(STR$(Minuten%), 2)
 ELSE
  Tmp$ = Tmp$ + "0" + RIGHT$(STR$(Minuten%), 1)
END IF
 Tmp$ = Tmp$ + ":"
IF Sekunden% > 9 THEN
  Tmp$ = Tmp$ + RIGHT$(STR$(Sekunden%), 2)
 ELSE
  Tmp$ = Tmp$ + "0" + RIGHT$(STR$(Sekunden%), 1)

END IF

Zeit$ = Tmp$
'StuMin$ = LEFT$(Tmp$, 5)
'MinSek$ = RIGHT$(Tmp$, 5)

END FUNCTION

FUNCTION Zeitmess
'Programmlaufzeit in Sekunden messen

'STATIC TAlt(),Tage&() 'Timerstand vom vorherigen Aufruf und
                       'Sekunden fuer vergangene Tage festhalten
TJetzt = Tmr           'aktuellen Timerstand holen

'Tageswechsel zu Mitternacht auswerten (24 Std = 86400 Sek)
IF TJetzt < TAlt(Kan%) THEN Tage&(Kan%) = Tage&(Kan%) + 86400

TAlt(Kan%) = TJetzt    'Timerstand vom vorherigen Aufruf

'Messzeit in Sekunden errechnen:
Zeitmess = TJetzt - TStart(Kan%) + Tage&(Kan%)


END FUNCTION

